define({      
//begin v1.x content
// local representation of all CSS3 named colors, companion to dojo.colors.  To be used where descriptive information
// is required for each color, such as a palette widget, and not for specifying color programatically.

//Note: due to the SVG 1.0 spec additions, some of these are alternate spellings for the same color (e.g. gray / grey).
//TODO: should we be using unique rgb values as keys instead and avoid these duplicates, or rely on the caller to do the reverse mapping?
aliceblue: "светло азурна",
antiquewhite: "боја на шампањ",
aqua: "аква",
aquamarine: "аквамарин",
azure: "азурна",
beige: "беж",
bisque: "бадемаста",
black: "црна",
blanchedalmond: "светло костенлива",
blue: "сина",
blueviolet: "виолетово-сина",
brown: "кафеава",
burlywood: "нежноскостенлива",
cadetblue: "сивкасто-сина",
chartreuse: "жолтозелена",
chocolate: "чоколадна",
coral: "црвеножолта",
cornflowerblue: "различкова сина",
cornsilk: "жолтокостенлива",
crimson: "темно црвена",
cyan: "тиркизна",
darkblue: "темно сина",
darkcyan: "темно тиркизна",
darkgoldenrod: "темно златнокостенлива",
darkgray: "темно сива",
darkgreen: "темно зелена",
darkgrey: "темно сива", // same as darkgray
darkkhaki: "темно маслинестозелена",
darkmagenta: "темно магента",
darkolivegreen: "темно маслинестозелена",
darkorange: "темно портокалова",
darkorchid: "темно виолетова",
darkred: "темно црвена",
darksalmon: "темно костенлива",
darkseagreen: "темно морско-сина",
darkslateblue: "темно виолетовосина",
darkslategray: "темно виолетовосива",
darkslategrey: "темно сива", // same as darkslategray
darkturquoise: "темно тиркизна",
darkviolet: "темно виолетова",
deeppink: "темно розова",
deepskyblue: "темно небесносина",
dimgray: "затемнето сива",
dimgrey: "затемнето сива", // same as dimgray
dodgerblue: "темно азурна сина",
firebrick: "темно црвена",
floralwhite: "темно бела",
forestgreen: "растително зелена",
fuchsia: "циклама",
gainsboro: "бледо сива",
ghostwhite: "сивкасто бела",
gold: "златна",
goldenrod: "златнокостенлива",
gray: "сива",
green: "зелена",
greenyellow: "зеленкасто жолтеникава",
grey: "сива", // same as gray
honeydew: "светла пролетно зелена",
hotpink: "изразена розова",
indianred: "светло бордо",
indigo: "индиго",
ivory: "слонова коска",
khaki: "маслинестозелена",
lavender: "лаванда",
lavenderblush: "светло лаванда",
lawngreen: "изразена светло зелена",
lemonchiffon: "бледо жолтеникава",
lightblue: "светло сина",
lightcoral: "светло корална",
lightcyan: "светло тиркизна",
lightgoldenrodyellow: "светло златнокоснливо жолта",
lightgray: "светло сива",
lightgreen: "светло зелена",
lightgrey: "светло сива", // same as lightgray
lightpink: "светло розова",
lightsalmon: "светло костенлива",
lightseagreen: "светло морскозелена",
lightskyblue: "светло небесносина",
lightslategray: "светло нејасна сива",
lightslategrey: "светло нејасно сива", // same as lightslategray
lightsteelblue: "светло сивкастосина",
lightyellow: "светло жолта",
lime: "зеленожолта",
limegreen: "жолтеникавозелена",
linen: "ленена",
magenta: "магента",
maroon: "костенлива",
mediumaquamarine: "средна аквамарин",
mediumblue: "средно сина",
mediumorchid: "средно темно бела",
mediumpurple: "средно вилетова",
mediumseagreen: "средно морско зелена",
mediumslateblue: "средно пурпурно сина",
mediumspringgreen: "средно растително зелена",
mediumturquoise: "средно тиркизна",
mediumvioletred: "средно виолетово црвена",
midnightblue: "средно сина",
mintcream: "нанекремова",
mistyrose: "бледорозова",
moccasin: "бледо костенлива",
navajowhite: "бледо портокалова",
navy: "морнарско сина",
oldlace: "светло беж",
olive: "маслинеста",
olivedrab: "света маслинестозелена",
orange: "портокалова",
orangered: "портокалово-црвена",
orchid: "темно бела",
palegoldenrod: "бледо златнокостенлива",
palegreen: "бледо зелена",
paleturquoise: "бледо тиркизна",
palevioletred: "бледо виолетово-црвена",
papayawhip: "бледо шампањско",
peachpuff: "бледо праска",
peru: "перу",
pink: "розова",
plum: "темновиолетова",
powderblue: "бледо сина",
purple: "виолетова",
red: "црвена",
rosybrown: "розово кафеава",
royalblue: "изразито сина",
saddlebrown: "светло кафеава",
salmon: "костенлива",
sandybrown: "песочно кафеава",
seagreen: "морско зелена",
seashell: "изразито бела",
sienna: "светло кафеава",
silver: "сребрена",
skyblue: "небесносина",
slateblue: "пурпурно-сина",
slategray: "изразито сива",
slategrey: "изразито сива", // same as slategray
snow: "снежно бела",
springgreen: "светло пролетно-зелена",
steelblue: "челичносина",
tan: "жолтокафена",
teal: "синозелена",
thistle: "бледо виолетова",
tomato: "светло црвена",
transparent: "проѕирна",
turquoise: "тиркизна",
violet: "виолетова",
wheat: "светло жолта",
white: "бела",
whitesmoke: "димно бела",
yellow: "жолта",
yellowgreen: "жолто-зелена"
//end v1.x content
});

